/********************************************************copyrite.xic********/
/*                                                                          */
/*   Licensed Materials - Property of IBM                                   */
/*   IBM TCP/IP for OS/2                                                    */
/*   (C) Copyright IBM Corporation. 1990,1991.                              */
/*                                                                          */
/*   All rights reserved.                                                   */
/*                                                                          */
/*   US Government Users Restricted Rights -                                */
/*   Use, duplication or disclosure restricted by GSA ADP Schedule          */
/*   Contract with IBM Corp.                                                */
/*                                                                          */
/*--------------------------------------------------------------------------*/
/*                                                                          */
/*  DISCLAIMER OF WARRANTIES.  The following [enclosed] code is             */
/*  sample code created by IBM Corporation. This sample code is not         */
/*  part of any standard or IBM product and is provided to you solely       */
/*  for  the purpose of assisting you in the development of your            */
/*  applications.  The code is provided "AS IS", without                    */
/*  warranty of any kind.  IBM shall not be liable for any damages          */
/*  arising out of your use of the sample code, even if they have been      */
/*  advised of the possibility of such damages.                             */
/*--------------------------------------------------------------------------*/
/*
 * Include Files.
 */
#define FOREVER 	1

#include <stdio.h>
#include <stdlib.h>
#include <types.h>
#include <netinet\in.h>
#include <sys\socket.h>
#include <netdb.h>
#include <sys/time.h>
#include <unistd.h>
#include <string.h>
#include <dos.h>
#include <conio.h>
#include <nerrno.h>
#include <sys\ioctl.h>
#include <net\route.h>
#include <net\if.h>
#include <net\if_arp.h>

/*
 * Client Main.
 */
int main(int argc, char *argv[])
{
    unsigned short port;       /* port client will connect to              */
    char buf[512], buf2[512];              /* data buffer for sending and receiving    */
    struct hostent *hostnm;    /* server host name information             */
    struct sockaddr_in server; /* server address                           */
    int s, rc;                     /* client socket                            */
    int dontblock = 1, i;
	char *rc1;
    FILE * fp; 

   	setbuf (stdout, NULL);
   	 
    /*
     * Check Arguments Passed. Should be hostname and port.
     */
    if (argc != 3)
    {
        fprintf(stderr, "Usage: %s hostname port\n", argv[0]);
        exit(1);
    }

    sock_init();

    /*
     * The host name is the first argument. Get the server address.
     */
    hostnm = gethostbyname(argv[1]);
    if (hostnm == (struct hostent *) 0)
    {
        fprintf(stderr, "Gethostbyname failed\n");
        exit(2);
    }

    /*
     * The port is the second argument.
     */
    port = (unsigned short) atoi(argv[2]);

    /*
     * Put a message into the buffer.
     */
    strcpy(buf, "the message");

    /*
     * Put the server information into the server structure.
     * The port must be put into network byte order.
     */
    server.sin_family      = AF_INET;
    server.sin_port        = htons(port);
    server.sin_addr.s_addr = *((unsigned long *)hostnm->h_addr);

    i = 0;
    do {
        /*
         * Get a stream socket.
        */
     
        if ((s = socket(PF_INET, SOCK_STREAM, 0)) < 0)
        	{
            psock_errno("Socket()");
            exit(3);
        	}
        if (connect(s, (struct sockaddr *)&server, sizeof(server)) < 0)
           	{
            psock_errno("Connect()");
            exit(4);
          	}

        rc = ioctl(s, FIONBIO, (char *) &dontblock);	// Put in non-blocking mode
  
    	do {
        	sleep (5);
    		fp = fopen( "\pipe\MBMon2\Data", "r" ); 
    		if( fp != NULL ) break;
    		i++;
	        if (i > 3) {
           		printf ("Error opening pipe\n");
           		exit (1);
           		}
           }
           while (FOREVER);  
    
		while ( (rc1 = fgets (buf, 250, fp)) != NULL) {
        	printf ("%s", buf);
//    		delay( 20 );  /* delay for 20 ms */
        	}
    
        fclose( fp );
            
        if (i = soclose(s) != 0) {
       		psock_errno("soclose() ");
       	    }
	    
    	} 
    	while (!kbhit());
     
	return 0;
}


